.. _oskar_script:

Beam-gain calculation with OSKAR
================================

The :code:`oskar_sim_beam_gain_sing.py` script is used to run OSKAR to calculate the beam gain in the direction of
each transmitter for one or more SKA stations. This can be run in one of two ways, using an installed version of OSKAR
or using a containerised (Singularity) version of OSKAR. The python script will determine the version to use,
by default trying first the Singularity image, and if that doesn't exist, reverting to the installed version.
If the containerised version is used, it should be located in the **rfi** directory. This can be replaced by a
newer version as required and can be downloaded from the `OSKAR repository <https://github.com/OxfordSKA/OSKAR/>`_.

For further information please see the `OSKAR documentation <https://github.com/OxfordSKA/OSKAR/releases>`_.

Simulation inputs
-----------------

OSKAR telescope configuration
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

A telescope configuration file for OSKAR containing SKA Low station information. For full details see the OSKAR
documentation. As appropriate those provided with OSKAR can be used and may provide more up-to-date configuration
information. By default a copy of a configuration file is used in
`rfi/data/telescope_files/SKA1-LOW_SKO-0000422_Rev3_38m_SKALA4_spot_frequencies.tm`.

HDF5 input and output
---------------------

The script uses the HDF5 output file from :ref:`pycraf_scripts` script, with structure explained
at :ref:`rfi_interface`, and write the results into another HDF5 file, which is based on the following class:

.. autoclass:: rfi.rfi_interface.rfi_data_cube.BeamGainDataCube
   :members:
   :undoc-members:

This is true, as long as the transmitter HDF5 file name is supplied via the :code:`--input_hdf_file` CLI argument.
By default, it is set to `tv_transmitter_attenuation_cube.hdf5`, which is the default output generated by
the :ref:`pycraf_scripts` script.

When the script is run this way, OSKAR performs calculations per SKA station.
The OSKAR output files are only temporarily saved, then read back in so the
data can be exported to HDF5. At the end of the run, the temporary files are removed.
The HDF5 file also contains pointing information (i.e right ascension and declination),
which is used as input for :ref:`rascil_scripts`.

Transmitter data
^^^^^^^^^^^^^^^^

Alternatively, one can supply an updated transmitter CSV file and individual azimuth-elevation files,
created by the :ref:`pycraf_scripts` script, via the :code:`--transmitters` and :code:`--indir` CLI arguments.
You also have to set the :code:`--input_hdf_file` CLI argument to an empty string (:code:`""`) explicitly,
to avoid using the HDF5 set-up.

In this case, OSKAR calculates beam gains for the array centre, given by the single az-el input for each transmitter
(instead of a value per transmitter per SKA station). For more information on the transmitter data,
follow :ref:`transmitters`.

The python script outputs beam-gain values as a function of frequency as txt files.

Command line arguments
----------------------

:ref:`oskar_cli`
